﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using EmbeddedReport.ReportExecution2005;
using System.Web.Services.Protocols;  

namespace EmbeddedReport
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }
        static string GetReportXML_VS2008(string ReportPath)
        {
            //creates a new Web service (proxy) and set its credentials 
            ReportExecutionServiceSoapClient rs = new ReportExecutionServiceSoapClient(); 
            //windows authentication
            //rs.ClientCredentials.Windows.AllowedImpersonationLevel = System.Security.Principal.TokenImpersonationLevel.Impersonation; 
            
            rs.ClientCredentials.UserName.UserName = "Domain\User";
            rs.ClientCredentials.UserName.Password = "Password";

            // Setup Render() call
            byte[] result = null;
            string encoding, mimeType, extension, DeviceInfo=null;
            Warning[] warnings = null;
            string[] streamIDs = null;

            try
            {
                //Should be called prior to Render() to set report’s path
                string historyID = null;
                ExecutionInfo ExecInfo; 
                ExecutionHeader ExecHeader;
                ServerInfoHeader SvrInfoHeader;

                //Note: set TrustedUserHeader parameter = null, this is undocumented structure
                ExecHeader = rs.LoadReport(null, ReportPath, historyID, out SvrInfoHeader, out ExecInfo);

                ParameterValue[] parameters = new ParameterValue[1];
                parameters[0] = new ParameterValue();
                parameters[0].Name = "SalesOrderNumber";
                parameters[0].Value = "SO43659";
                //rs.SetExecutionParameters(parameters, "en-us");


                rs.SetExecutionParameters(ExecHeader, null, parameters, "en-us", out ExecInfo);

                rs.Render(ExecHeader, null, "XML", DeviceInfo, out result, out extension,
                    out mimeType, out encoding, out warnings, out streamIDs);
                

                //Gets a byte stream with Comma Separated Value (XML) layout
                return System.Text.Encoding.ASCII.GetString(result);
            }
            catch (Exception e)
            {
                //Return exception message, if exception occured
                return e.Message;
            }
        }

        private void btnTest_Click(object sender, EventArgs e)
        {
            txtResult.Text = GetReportXML_VS2008("/ReportProject/TopSalesPeople");
        }

    }

}

