using System;
using System.Collections.Generic;
using System.IO;
using System.Text;

using Microsoft.ReportingServices.Interfaces;

namespace TestRdce
{
    public class TestRdce : IReportDefinitionCustomizationExtension
    {
        #region IReportDefinitionCustomizationExtension Members

        public bool ProcessReportDefinition(
            byte[] reportDefinition, 
            IReportContext reportContext,
            IUserContext userContext,
            out byte[] reportDefinitionProcessed)
        {
            string targetReportName;
            if (reportContext.IsLinkedReport)
            {
                targetReportName = reportContext.LinkedReportTargetName;
            }
            else
            {
                targetReportName = reportContext.ReportName;
            }

            FileStream fs = new FileStream(@"d:\tmp\report1\" + targetReportName + "Replaced.rdl", FileMode.Open);
            reportDefinitionProcessed  = new byte[fs.Length];
            fs.Read(reportDefinitionProcessed, 0, reportDefinitionProcessed.Length);
            fs.Close();

            return true;
        }

        #endregion

        #region IExtension Members

        public string LocalizedName
        {
            get { return "TestRde";  }
        }

        public void SetConfiguration(string configuration)
        {
            return;
        }

        #endregion
    }
}
